#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: autoDelete.cgi,v 1.11 2003/06/13 16:48:45 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/autoDelete.cgi,v $

########################################################################
# autoDelete.cgi
#
# Script for controlling the Auto file deletion mode.
# This script is called without any parameters.  It puts up a form
# that allows the user to control the AutoDelete function.
# When the user clicks OK, the paramters are fed to the access
# controlled script 'gpsadmin/setAutoDelete.cgi'
# 
# The AutoDelete control is saved in a configuration file -
# /etc/sysconfig/autoDelete, which contains a single line with 'yes'
# or 'no'.
########################################################################

use strict ;
use CGI qw/:standard/;

use Fireball ;

titleWithHelp( 'Data Logging AutoDelete Mode',
               '/autoDeleteInfo.html'
             ) ;

# Declare the variables local to this file.
my ($Enable) ;

if ( open( AUTODELETE, '/etc/sysconfig/autoDelete' ) )
{
  $Enable = <AUTODELETE> ;
  close AUTODELETE ;
  chomp $Enable ;
  ($Enable, undef) = split( ' ',$Enable ) ;
}
else
{
  $Enable = 'yes' ;
}


print start_form( -name=>'theForm', 
                  -action=>'/perl-scripts/gpsadmin/setAutoDelete.cgi'
                ) ;

print b('AutoDelete Mode');
print '<br><br>',
      'Automatically delete the oldest logged files, as needed, to ',
      'make room for new files?' ;

my @buttons = radio_group( -name=>'Enable', 
                        -value=>['yes','no'],
                        -nolabels=>1,
                        -default=>$Enable,
                      ) ;

print table(
             Tr( td( $buttons[0] ),
                 td( 'Yes.  Delete old files as needed.',
                   )
               ),
             Tr( td( $buttons[1] ),
                 td( 'No.  Stop logging when space is used up.' )
               ),
           ) ;


print hr() ;

print button( -name=>'OK', 
              -value=>'OK',
              -onClick=>'parent.submitForm( document.theForm, "" )'
            ) ;

print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
                  'parent.loadDataFrame( "/perl-scripts/sessions.cgi" )'
            ) ;
print end_form() ;

print end_html() ;

########################################################################
# end of script autoDelete.cgi
########################################################################
