#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: download.cgi,v 1.2.4.1 2003/10/30 23:22:25 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/fileaccess/download.cgi,v $

########################################################################
# download.cgi
#
# CGI script for downloading logged data files.
# Called with CGI parameter:
#       
#   ?file=filepath  (relative to /var/gps)
#
# The Logged Data files are rooted at /var/gps/.  This script sends
# back the data file, with an http wrapper that requests a browser to
# save the data into a file on the browsing computer.
#
# This is an odd script because it doesn't return a web page.  Instead,
# we send back an "attachment" document, which indicates to the browser
# that its contents should be saved into a file on the user's computer.
# This is done by sending some special parameters in the http header.
#
# This script, with a tiny bit of filtering could be used by other means
# besides a browser to download files over the http link.  For example
# a perl program could be made to grab a file as a sort of FTP program.
# Because this program is in the perl-script/fileaccess directory, it
# may have http password requirements, which such programs would have to
# deal with.
#
########################################################################

use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;

my $Rootdir='/var/gps' ;

if (my $fname = param('file'))
{
  my $pathname = $Rootdir.$fname ; # The full path to the real file.

  sendBinaryFile( $pathname ) ;
}

########################################################################
# end of script download.cgi
########################################################################
