#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: ftp.cgi,v 1.9.2.1 2003/10/30 22:48:16 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/ftp.cgi,v $

########################################################################
# perl-scripts/ftp.cgi
#
# This script displays the current state of the FTP system.
#
# A "MODIFY" button starts the data entry process to select a
# different mode or change the setup parameters.
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'FTP Configuration',
               '/ftpInfo.html'
             ) ;


# Read in the contents of /etc/ftpaccess to determine current setup
# The variabilities here are best understood by examining
# /etc/ftpaccess, which is well documented.  Look for "GUI WILL EDIT" to
# find the relevant lines.
my $anonEnabled ;
my $namedEnabled ;
my $adminEnabled ;
my $anonDeleting ;
my $namedDeleting ;
my $namedPassword ; # Dummy parameter.  Not really used in this sub.
my $adminPassword ; # Dummy parameter.  Not really used in this sub.
readFTPSetup( \$anonEnabled, 
              \$namedEnabled,
              \$adminEnabled,
              \$anonDeleting,
              \$namedDeleting,
              \$namedPassword,
              \$adminPassword
            ) ;


print '<Table border="0"> <tr>' ;

print th( {align=>'right'}, 'Anonymous FTP :') ;
print td( {align=>'left'},
          'For user "<b>anonymous</b>" or "<b>ftp</b>" :',
          '<br>Download of logged data files is ',
          ($anonEnabled 
            ? '<b>Enabled.</b>'.
              '<br>File deletion is <b>'.
              ( $anonDeleting 
                ? 'Enabled</b>.'
                : 'Disabled</b>.' 
              )
            : '<b>Disabled</b>.'
          )
        ) ;
print '</tr><tr><td>&nbsp;</td></tr>' ;

print th( {align=>'right'}, 'Named FTP :') ;
print td( {align=>'left'},
          'For user "<b>netrsFTP</b>" :',
          '<br>Download of logged data files is ',
          ($namedEnabled 
            ? '<b>Enabled.</b>'.
              '<br>File deletion is <b>'.
              ( $namedDeleting 
                ? 'Enabled</b>.'
                : 'Disabled</b>.' 
              )
            : '<b>Disabled</b>.'
          )
        ) ;
print '</tr><tr><td>&nbsp;</td></tr>' ;

print th( {align=>'right'}, 'Administration FTP :') ;
print td( {align=>'left'},
          'For user "<b>adminFTP</b>" :',
          '<br>Upload of firmware files is ',
          ($adminEnabled 
          ? '<b>Enabled.</b><br>File deletion is <b>Enabled</b>.' 
          : '<b>Disabled</b>.'),
          
        ) ;
print "</tr>" ;
print '</Table>' ;


# Start the form portion of the page.
print startform() ;

print button( -name=>'Modify', 
              -value=>'Modify',
              -onClick=>
       'parent.loadDataFrame( "/perl-scripts/sysadmin/ftpConfig.cgi" ) '
            ) ;
print endform() ;


print end_html() ;

########################################################################
# End of script ftp.cgi
########################################################################
