#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setAutoDelete.cgi,v 1.4 2003/06/13 16:48:48 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setAutoDelete.cgi,v $

########################################################################
# setAutoDelete.cgi
#
# Finalizes a user choice for the AutoDelete control.
# Typically called from perl-scripts/autoDelete.cgi when the user has
# clicked the OK button.  That submits the form information to this
# script, with a single parameter:
#
#       Enable   = 'yes' or 'no'
# 
# The new setting is saved in a configuration file -
# /etc/sysconfig/autoDelete, which contains a single line with 'yes'
# or 'no'.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set AutoDelete' ) ;


#  for my $p (param())
#  {
#    print "$p = ",param($p),br() ;
#  }

my $enable = param('Enable') ;
if ($enable ne 'yes' and $enable ne 'no')
{
  print 'Parameters not properly specified!' ;
  print '<Script>parent.loadAfterDelay("/perl-scripts/autoDelete.cgi", 2000);</Script>' ;
}
else
{
  # Create a new configuration file and then copy it 
  # into /etc/sysconfig.
  open( AUTODELETE, '>/tmp/autoDelete' ) ;
  print AUTODELETE $enable, "\n" ;
  close AUTODELETE ;
  system( 'sudo cp /tmp/autoDelete /etc/sysconfig' ) ;

  
  # Send signal 1 (SIGHUP) to the autoDelete daemon to inform it that 
  # the configuration may have been changed.
  if ( -f '/var/run/logScheduler.pid' )
  {
    my $spid = qx( cat /var/run/autoDelete.pid ) ;
    #print "Signalling $spid <br>\n" ;
    system( "/usr/bin/sudo /bin/kill -SIGHUP $spid" ) ;
  }

  # Indicate what the new control is set to.
  print h2('AutoDelete Mode is ',
            $enable eq 'yes' 
            ? 'Enabled.'
            : 'Disabled.'
          ) ;

  # Switch back to the Sessions display page.
  print '<Script>parent.loadAfterDelay( "/perl-scripts/sessions.cgi", 
                                        2000);</Script>' ;
}

print end_html() ;

########################################################################
# end of script setAutoDelete.cgi
########################################################################
