#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setEnaDis.cgi,v 1.5 2003/06/13 16:48:48 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setEnaDis.cgi,v $

########################################################################
# setEnaDis.cgi
#
# Sets the enable/disable controls on GPS satellites in accordance with
# the CGI parameters given to the script.  This script is primarily
# invoked from /perl-scripts/setEnaDis.cgi, which implements an html
# form for the user to fill in with the desired satellite enable and
# ignorehealth settings.  When the OK button is clicked the other
# buttons are encoded as CGI parameters and sent here.
#
# It is assumed that a full set of Enables/Disables/Ignores is being
# set.  The parameters that actually come in are based on the check
# boxes that are checked.  If an Enable checkbox is set then there will
# be a parameter like "Enable12" where 12 is a prn number.  A similar
# parameter will come in for every IgnoreHealth checkbox, named like
# "Ignore23".  The cgi request, thus would look like this:
# satEnabDis.cgi?Enable1=1&Enable2=1&Ignore2=1&....  If there are no
# Enable or Ignore parameters for a particular PRN, then that prn is
# disabled.
#
# When the
#
########################################################################


use strict ;
use CGI qw/:standard/;
use IO::Socket;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set GPS Enable/Disable' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


# Create a command line of the form
#   put sv_masks E E E D E E E E I E .....
# with an E/D/I character for all 32 satellites.
# this line will be sent to stinger and written into Stinger's
# configuration file.
my $commandLine = 'put sv_masks' ;

for (my $i = 1 ; $i <= 32 ; ++$i )
{
  $commandLine .= param('Ignore'.$i)  
           ? ' I' 
           : param('Enable'.$i) 
             ? ' E' 
             : ' D' ;
}

$commandLine .= "\n" ;
#print $commandLine ;

my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
connect(SOCK,$sun)|| die "connect: $!";
SOCK->autoflush(1);

print( SOCK  $commandLine ) ;
$_ = <SOCK> ; # Read and toss the OK
#print $_ ;

close(SOCK) ;

# Update the stinger configuration file to make this change
# persist across power cycles.
open( NEWCONFIG, '>/tmp/stinger.cfg' ) ;

# Read and transfer the old data to the new file.  
# Leave out the command we are trying to modify.
if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
{
  while (<OLDCONFIG>)
  {
    next if (/put sv_masks/) ;
    print NEWCONFIG $_ ;
  }
}
close OLDCONFIG ;


print NEWCONFIG $commandLine ;

close NEWCONFIG ;

# Copy the new config file into the sysconfig area.
system( 'sudo cp /tmp/stinger.cfg /etc/sysconfig/stinger.cfg' ) ;


print h2("New Satellite controls have been set." ) ;
print <<EOF;
  <Script>
  parent.loadAfterDelay( "satGeneral.cgi", 1500) ;
  </Script>
EOF

print end_html() ;

########################################################################
# end of file setEnaDis.cgi
########################################################################
