#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setL2CSTracking.cgi,v 1.1.2.2 2003/11/18 20:52:00 kathy Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setL2CSTracking.cgi,v $

########################################################################
# setL2CSTracking.cgi
#
# Sets the control for the L2CS Tracking function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   L2CSTracking mode : 'on' or 'off'
#
# Stinger is controlled by using the command
#
#       put l2cs_mode [off|on]
#
# The 'put l2cs_mode [on|off]' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;
use IO::Socket;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set L2CSTracking' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $CSstate = param( 'L2CSTracking' ) ;
if ($CSstate =~ m/^on|off$/ )
{
  my $line = 'put l2cs_mode '.$CSstate."\n" ;

  # Contact Stinger and send the command line to it.
  my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
  socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
  connect(SOCK,$sun)|| die "connect: $!";
  SOCK->autoflush(1);

  print( SOCK  $line ) ;
  $_ = <SOCK> ; # Get the OK response
  close(SOCK) ;

  # Update the stinger configuration file to make this change
  # persist across power cycles.
  open( NEWCONFIG, '>/tmp/stinger.cfg' ) ;

  # Read and transfer the old data to the new file.  
  # Leave out the commands we are trying to modify.
  if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
  {
    while (<OLDCONFIG>)
    {
      next if (/put l2cs_mode/) ;
      print NEWCONFIG $_ ;
    }
  }
  close OLDCONFIG ;

  print NEWCONFIG $line ;

  close NEWCONFIG ;

  system( 'sudo cp /tmp/stinger.cfg /etc/sysconfig/stinger.cfg' ) ;

  print h2( "L2C Tracking has been ",
            $CSstate eq 'on'
            ? 'enabled.'
            : 'disabled.'
          ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setL2CSTracking.cgi
########################################################################
