#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setMasks.cgi,v 1.6 2003/06/13 16:48:49 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setMasks.cgi,v $

########################################################################
# setMasks.cgi
#
# CGI script to implement the setting of the PDOP and Elevation masks.
# Called from perl-scripts/masks.cgi with parameters like this:
#
#   setMasks.cgi?elevMask=10&pdopMask=7
#
# In response, this script parses the parameters, updates the 
# stinger configuration file, puts up an "Okay, I did it" message, and
# then switches back to the rconfigDisplay page.
########################################################################

use strict ;
use CGI qw/:standard/;
use IO::Socket;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Masks' ) ;

#print( '<BR>Parameters Received:<BR>' ) ;
#foreach my $p (param())
#{
#    print( "$p=", param($p), '<BR>' ) ;
#}
#print '<BR>' ;


my $elevMask = param('elevMask') ;
my $pdopMask = param('pdopMask') ;

if ( defined( $elevMask )
 and defined( $pdopMask) 
 and ($elevMask ne '') 
 and ($pdopMask ne '') 
   )
{
  print h2( "Changing Elevation Mask to $elevMask" ) ;
  print h2( "Changing Pdop Mask to $pdopMask" ) ;

  my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
  socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
  connect(SOCK,$sun)|| die "connect: $!";
  SOCK->autoflush(1);

  print( SOCK "put elev_mask $elevMask\n" ) ;

  print( SOCK "put pdop_mask $pdopMask\n" ) ;

  <SOCK> ; # Read and discard 'OK'

  close(SOCK) ;

  # Update the stinger configuration file to make this change
  # persist across power cycles.
  open( NEWCONFIG, '>/tmp/stinger.cfg' ) ;

  # Read and transfer the old data to the new file.  
  # Leave out the command we are trying to modify.
  if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
  {
    while (<OLDCONFIG>)
    {
      next if (/put elev_mask/) ;
      next if (/put pdop_mask/) ;
      print NEWCONFIG $_ ;
    }
  }
  close OLDCONFIG ;


  print( NEWCONFIG "put elev_mask $elevMask\n" ) ;
  print( NEWCONFIG "put pdop_mask $pdopMask\n" ) ;

  close NEWCONFIG ;

  system( 'sudo cp /tmp/stinger.cfg /etc/sysconfig/stinger.cfg' ) ;


  print <<EOF;
      <Script>
      parent.loadAfterDelay( 'rconfigDisplay.cgi', 1000) ;
      </Script>
EOF

}
else
{
  print h2('Invalid Parameters to setMasks.cgi' ) ;
}

print end_html() ;

########################################################################
# end of file setMasks.cgi
########################################################################
