#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setMultipath.cgi,v 1.6 2003/06/13 16:48:49 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setMultipath.cgi,v $

########################################################################
# setMultipath.cgi
#
# Sets the control for the Multipath function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   Multipath : 'on' or 'off'
#
# Multipath in Stinger is controlled by using the command
#
#       put everest [off|on]
#
# The 'put everest [on|off]' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;
use IO::Socket;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Multipath' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $MPstate = param( 'Multipath' ) ;
if ($MPstate =~ m/^on|off$/ )
{
  my $line = 'put everest '.$MPstate."\n" ;

  # Contact Stinger and send the command line to it.
  my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
  socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
  connect(SOCK,$sun)|| die "connect: $!";
  SOCK->autoflush(1);

  print( SOCK  $line ) ;
  $_ = <SOCK> ; # Get the OK response
  close(SOCK) ;

  # Update the stinger configuration file to make this change
  # persist across power cycles.
  open( NEWCONFIG, '>/tmp/stinger.cfg' ) ;

  # Read and transfer the old data to the new file.  
  # Leave out the commands we are trying to modify.
  if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
  {
    while (<OLDCONFIG>)
    {
      next if (/put everest/) ;
      print NEWCONFIG $_ ;
    }
  }
  close OLDCONFIG ;

  print NEWCONFIG $line ;

  close NEWCONFIG ;

  system( 'sudo cp /tmp/stinger.cfg /etc/sysconfig/stinger.cfg' ) ;

  print h2( "Multipath Reduction has been ",
            $MPstate eq 'on'
            ? 'enabled.'
            : 'disabled.'
          ) ;

  # After a timeout, go back to main configuration summary page.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 1000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setMultipath.cgi
########################################################################
