#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setPps.cgi,v 1.6 2003/06/13 16:48:49 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setPps.cgi,v $

########################################################################
# setPps.cgi
#
# Accepts new controls for the Pulse-Per-Second feature.
# This script is called from the perl-script/pps.cgi script, when the
# user uses "OK" to accept new parameters for controlling the PPS
# setup.  The form data is submitted to this CGI script.
# The stinger control state is changed to match the settings.  The
# parameters are:
#   PpsEnable  either 'On' or 'Off '
#   PpsSlope   either 'Positive' or 'Negative'.
#
# For example, the url might look like:
#
#   perl-scripts/gpsadmin/setPps.cgi?PpsEnable=On&PpsSlope=Negative
#
# The pps configuration is saved in a line from 
# /etc/sysconfig/stinger.cfg.  The line is of the forms: 
#
#   put pps_mode on pos
#   put pps_mode off neg
#
# That same format is used for direct control of Stinger using the
# socket connections.  
#
########################################################################


use strict ;
use CGI qw/:standard/;
use IO::Socket;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set PPS' ) ;

#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p ", param($p), "\n" ;
#}

my $ppsEnable = param( 'PpsEnable' ) ;
my $ppsSlope =  param( 'PpsSlope' ) ;

if ( defined( $ppsEnable )
 and defined( $ppsSlope )
 and ($ppsEnable ne '') 
 and ($ppsSlope ne '') 
   )
{

  if ($ppsEnable eq 'On')
  {
    print h2( 'Pulse Per Second output is Enabled.' ) ;
    print h2( "Timing edge is $ppsSlope going." ) ;
  }
  else
  {
    print h2( 'Pulse Per Second output is Disabled.' ) ;
  }

  my $sun = sockaddr_un('/var/stinger/config')|| die "no config";
  socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
  connect(SOCK,$sun)|| die "connect: $!";
  SOCK->autoflush(1);

  
  my $line = 'put pps_mode '
             .( ($ppsEnable eq 'On') ? 'on ' : 'off ' )
             .( ($ppsSlope eq 'Positive') ? 'pos' : 'neg' )
             ."\n" ;

  #print $line ;
  print( SOCK  $line ) ;
  $_ = <SOCK> ;
  #print $_ ;

  close(SOCK) ;
  #print '</PRE>' ;
  
  # Update the stinger configuration file to make this change
  # persist across power cycles.
  open( NEWCONFIG, '>/tmp/stinger.cfg' ) ;

  # Read and transfer the old data to the new file.  
  # Leave out the commands we are trying to modify.
  if ( open( OLDCONFIG, '/etc/sysconfig/stinger.cfg' ) )
  {
    while (<OLDCONFIG>)
    {
      next if (/put pps_mode/) ;
      print NEWCONFIG $_ ;
    }
  }
  close OLDCONFIG ;


  print NEWCONFIG $line ;

  close NEWCONFIG ;

  system( 'sudo cp /tmp/stinger.cfg /etc/sysconfig/stinger.cfg' ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF

}
else
{
  print h2( 'Missing parameters to setPps.cgi' ) ;
}

print end_html() ;


########################################################################
# end of file setPps.cgi
########################################################################
