#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: portSummary.cgi,v 1.17.2.1 2003/10/30 23:02:24 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/portSummary.cgi,v $

########################################################################
# portSummary.cgi
#
# Script for displaying the summary of Input/Output port configuration.
# This describes the Serial port configurations and any TCP/UDP ports
# that have been set up for streaming.
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'Input/Output Summary',
               '/portInfo.html'
             ) ;


########################################################################
# Make all links blue with no underlines, even if visited, etc.
# This is a document-level style specification, affecting all
# links in this frame.
########################################################################
print <<EOF ;
<style type="text/css">
 <!--
       a {color:blue ; text-decoration: none }
 -->
</style>
EOF



# Read the complete port configuration into a hash structure.
my %allPortData ;
getPortSetup( \%allPortData ) ;


########################################################################
# Create the list of items for the table.
# Sort to put the Serial Ports first, followed by TCP,UDP.
# Include elements for creating new TCP/UDP port definitions.
########################################################################
my @portList = sort keys %allPortData ;

########################################################################
# Create the table containing the configuration data.
########################################################################
print '<Table align="center" border=1>' ;

print Tr( th( ['Port',
               '&nbsp;Service&nbsp;',
              ] 
            )
        );

foreach my $p (@portList)
{
  my $service = $allPortData{$p}{'service'} ;

  next if ($p eq 'MetControls') ;
  next if ($service eq 'internal4') ;
  next if ($service eq 'internal3') ;

  $service = 'PPP' if ($service eq 'ppp') ;
  $service = 'RTCM' if ($service eq 'Rtcm') ;
  $service = 'SV Status' if ($service eq 'SvStatus') ;

  my $name = $p ;
  $name =~ s/Port/ Port / ;
  $name =~ s/Tcp/TCP/ ;
  $name =~ s/Udp/UDP/ ;

  print Tr( {align=>'center'},
          td( '&nbsp;',
              a( {href=>'portSetup.cgi?restart='.CGI::escape($p)}, 
                 $name ) ,
              '&nbsp;'
            ),
          td( '&nbsp;'.$service.'&nbsp;', )
          );
}

print '</Table>' ;


########################################################################
# Some action link/buttons at the bottom of the page.
########################################################################
print '<br><br>' ;
print table( {align=>'center', width=>'50%', border=>2},
            Tr( td( {align=>'center', width=>'33%' },
                    a( {href=>'portSetup.cgi'} , 
                       'Edit<br>Port Setups' 
                     )
                  ),
                td( {align=>'center', width=>'33%'},
                    a( {href=>'portSetup.cgi?restart='.
                              CGI::escape( 'New TCP Port') },
                       'Create New<br>TCP Port'
                     )
                  ),
                td( {align=>'center', width=>'33%'},
                    a( {href=>'portSetup.cgi?restart='.
                              CGI::escape( 'New UDP Port') },
                       'Create New<br>UDP Port'
                     )
                  ),
              )
           ) ;


print end_html() ;

########################################################################
# end of script portSummary.cgi
########################################################################
