#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: configDownload.cgi,v 1.1 2003/06/03 15:40:49 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/configDownload.cgi,v $

########################################################################
# configDownload.cgi
# Script for downloading Fireball Configuration Files
# 
# Via the Web-GUI interface we can create, delete, download, upload and 
# apply "configuration files".  These are collections of Fireball
# control settings.  The files reside in /etc/sysconfig/configFiles.
#
# This script handles downloading a previously created configfile.
# It is passed a single CGI parameter which is the name of the
# config file that needs to be downloaded.
#
#     &download=fname
#
# This should pop up window on the user's computer asking where to
# store the data.
#
########################################################################

use strict ;
use CGI qw/:standard/;


if (my $fname = param('download'))
{
  # User wants to download an existing config file, through the browser
  # to a file on his Browser's CPU.
  # In this case, a return document isn't displayed.  We send a
  # special header indicating to the browser that it should save the
  # file.  That will cue the browser to prompt the user for a place
  # to store the file.

  my $fullpath = "/etc/sysconfig/configFiles/$fname" ;

  my $length = -s $fullpath ;

  print header( -type=>'application/octet-stream',
                -attachment=>param('download'),
                -'Content-length'=>$length,
                -expires=>'+1s'
              ) ;

  # Open and send the file.  We use binary reads in case the file
  # isn't ASCII.
  open THEFILE, $fullpath ;

  my $buf ;
  while ( read( THEFILE, $buf, 4096 ) )
  {
    print $buf ;
  }
}



########################################################################
# end of file configDownload.cgi
########################################################################
